# $Revision: 1.83 $, $Date: 2010/07/19 22:48:32 $
# TODO
# - subpackages? e.g. modules and utils
# - grubemu notes
#   --enable-grub-emu-usb conflicts with --enable-grub-emu-pci, emu-pci seems experimental
#   - to build and install the `grub-emu' debugging utility we need to re-run build with --target=emu
#   - put grub-emu to subpackage if it is fixed
#
# Conditional build:
%bcond_with	static	# build static binaries
%bcond_with		grubemu	# build grub-emu debugging utility
%bcond_without	efiemu	# build efiemu runtimes

%if "%{cc_version}" < "3.4"
# cc does not support:
# cc1: sorry, unimplemented: code model `large' not supported yet
%undefine	with_efiemu
%endif

Summary:	GRand Unified Bootloader
Summary(de.UTF-8):	GRUB2 - ein Bootloader für x86 und ppc
Summary(hu.UTF-8):	GRUB2 - rendszerbetöltő x86 és ppc gépekhez
Summary(pl.UTF-8):	GRUB2 - bootloader dla x86 i ppc
Summary(pt_BR.UTF-8):	Gerenciador de inicialização GRUB2
Name:		grub2
Version:	1.98
Release:	0.2
License:	GPL v2
Group:		Base
Source0:	http://alpha.gnu.org/gnu/grub/grub-%{version}.tar.gz
# Source0-md5:	c0bcf60e524739bb64e3a2d4e3732a59
Source1:	update-grub
Source2:	update-grub.8
Source3:	grub.sysconfig
Source4:	grub-custom.cfg
URL:		http://www.gnu.org/software/grub/grub-2.en.html
Patch0:		pld-initrd.patch
Patch1:		pld-sysconfdir.patch
Patch2:		grub-garbage.patch
Patch3:		grub-shelllib.patch
Patch4:		grub-install.in.patch
Patch5:		grub-lvmdevice.patch
Patch6:		pld-mkconfigdir.patch
Patch7:		grub-mkconfig-diagnostics.patch
Patch8:		ppc.patch
BuildRequires:	autoconf >= 2.53
BuildRequires:	automake >= 1:1.11.1-1
BuildRequires:	bison
BuildRequires:	gawk
BuildRequires:	help2man
BuildRequires:	libtool
BuildRequires:	texinfo
%ifarch %{ix86} %{x8664}
BuildRequires:	lzo-devel >= 1.0.2
%endif
%ifarch %{x8664}
BuildRequires:	/usr/lib/libc.so
%if "%{pld_release}" == "ac"
BuildRequires:	libgcc32
%else
BuildRequires:	gcc-multilib
%endif
%endif
BuildRequires:	ncurses-devel
BuildRequires:	sed >= 4.0
%if %{with static}
BuildRequires:	glibc-static
%ifarch %{ix86} %{x8664}
BuildRequires:	lzo-static
%endif
BuildRequires:	ncurses-static
%endif
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	rpmbuild(macros) >= 1.213
Provides:	bootloader
Conflicts:	grub
ExclusiveArch:	%{ix86} %{x8664} ppc sparc64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin
%define		_bindir		%{_sbindir}
%define		_libdir		/boot
%define		_libexecdir	%{_libdir}/grub

%description
GRUB is a GPLed bootloader intended to unify bootloading across x86
operating systems. In addition to loading the Linux and *BSD kernels,
it implements the Multiboot standard, which allows for flexible
loading of multiple boot images (needed for modular kernels such as
the GNU Hurd).

GRUB 2 is derived from PUPA which was a research project to
investigate the next generation of GRUB. GRUB 2 has been rewritten
from scratch to clean up everything for modularity and portability.

GRUB 2 targets at the following goals:
- Scripting support, such as conditionals, loops, variables and
  functions.
- Graphical interface.
- Dynamic loading of modules in order to extend itself at the run time
  rather than at the build time.
- Portability for various architectures.
- Internationalization. This includes support for non-ASCII character
  code, message catalogs like gettext, fonts, graphics console, and so
  on.
- Real memory management, to make GNU GRUB more extensible.
- Modular, hierarchical, object-oriented framework for file systems,
  files, devices, drives, terminals, commands, partition tables and OS
  loaders.
- Cross-platform installation which allows for installing GRUB from a
  different architecture.
- Rescue mode saves unbootable cases. Stage 1.5 was eliminated.
- Fix design mistakes in GRUB Legacy, which could not be solved for
  backward-compatibility, such as the way of numbering partitions.

%description -l de.UTF-8
GRUB (GRand Unified Boot-loader) ist ein Bootloader, der oft auf
Rechnern eingesetzt wird, auf denen das freie Betriebssystem Linux
läuft. GRUB löst den betagten LILO (Linux-Loader) ab.

GRUB wurde innerhalb des GNU Hurd-Projektes als Boot-Loader entwickelt
und wird unter der GPL vertrieben. Aufgrund seiner höheren
Flexibilität verdrängt GRUB in vielen Linux-Distributionen den
traditionellen Boot-Loader LILO.

%description -l hu.UTF-8
GRUB egy GPL liszenszű rendszerbetöltő. Linux és *BSD kernelek
betöltése mellett támogatja a Multiboot standard-ot, amely lehetővé
teszi boot képek betöltését (moduláris kerneleknek kell, mint pl. a
GNU Hurd).

GRUB2 céljai a következők:
- szkriptelés támogatása, úgymint feltételek, ciklusok, változók,
  függvények.
- grafikus felület
- modulok dinamikus betöltése futási időben
- hordozhatóság több architektúrára
- többnyelvűség: nem-ASCII karakterek támogatása, üzenetkatalógusok,
  mint gettext, betűtípusok, grafikus konzolon, és így tovább
- valós memória kezelés, amellyel még bővíthetőbbé tehetjük
- moduláris, hierarchikus, objektum-orientált keretrendszer
  fájlrendszerekhez, fájlokhoz, eszközökhöz, meghajtókhoz,
  terminálokhoz, parancsokhoz, partíciós táblákhoz és OS betöltőkhöz

%description -l es.UTF-8
Éste es GRUB - Grand Unified Boot Loader - un administrador de
inicialización capaz de entrar en la mayoría de los sistemas
operacionales libres - Linux, FreeBSD, NetBSD, GNU Mach, etc. como
también en la mayoría de los sistemas operacionales comerciales para
PC.

El administrador GRUB puede ser una buena alternativa a LILO, para
usuarios conmás experiencia y que deseen obtener más recursos de su
cargador de inicialización (boot loader).

%description -l pl.UTF-8
GRUB jest bootloaderem na licencji GNU, mającym na celu unifikację
procesu bootowania na systemach x86. Potrafi nie tylko ładować jądra
Linuksa i *BSD: posiada również implementacje standardu Multiboot,
który pozwala na elastyczne ładowanie wielu obrazów bootowalnych
(czego wymagają modułowe jądra, takie jak GNU Hurd).

%description -l pt_BR.UTF-8
Esse é o GRUB - Grand Unified Boot Loader - um gerenciador de boot
capaz de entrar na maioria dos sistemas operacionais livres - Linux,
FreeBSD, NetBSD, GNU Mach, etc. assim como na maioria dos sistemas
operacionais comerciais para PC.

O GRUB pode ser uma boa alternativa ao LILO, para usuários mais
avançados e que querem mais recursos de seu boot loader.

%prep
%setup -q -n grub-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%if "%{cc_version}" < "3.4"
grep -rl -- -Wno-missing-field-initializers . | xargs sed -i -e 's,-Wno-missing-field-initializers,,'
sed -i -e '/video_mod_CFLAGS/s/$/ -Wno-error/' conf/common.rmk
%endif

%build
cp -f /usr/share/automake/config.sub .
%{__libtoolize}
%{__aclocal}
%{__autoheader}
echo timestamp > stamp-h.in
%{__autoconf}
export CFLAGS="-Os %{?debug:-g}"

# mawk stalls at ./genmoddep.awk, so force gawk
AWK=gawk \
%configure \
%if %{with grubemu}
	--enable-grub-emu-usb \
	--enable-grub-emu-sdl \
	--enable-grub-emu-pci \
%endif
	--%{!?with_efiemu:dis}%{?with_efiemu:en}able-efiemu \
	BUILD_CFLAGS="$CFLAGS"
%{__make} -j1 \
	BUILD_CFLAGS="$CFLAGS" \
%if %{with static}
%ifarch %{ix86} %{x8664}
	grub_setup_LDFLAGS="-s -static" \
	grub_mkimage_LDFLAGS="-s -static -llzo" \
%else
	grub_mkimage_LDFLAGS="-s -static" \
%endif
	grub_emu_LDFLAGS="-s -static -lncurses -ltinfo" \
%endif
	pkgdatadir=%{_libexecdir} \
	pkglibdir=%{_libexecdir}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/sysconfig,%{_sysconfdir}/grub.d}

%{__make} install \
	pkgdatadir=%{_libexecdir} \
	pkglibdir=%{_libexecdir} \
	DESTDIR=$RPM_BUILD_ROOT

cp -a docs/grub.cfg $RPM_BUILD_ROOT%{_libexecdir}
install -p %{SOURCE1} $RPM_BUILD_ROOT%{_sbindir}/update-grub
cp -a %{SOURCE2} $RPM_BUILD_ROOT%{_mandir}/man8/update-grub.8
cp -a %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/grub
cp -a %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/grub.d/custom.cfg
rm -f $RPM_BUILD_ROOT%{_infodir}/dir

# deprecated. we don't need it
rm $RPM_BUILD_ROOT/lib/update-grub_lib

# no junk to /boot/grub (put to -devel?)
rm $RPM_BUILD_ROOT%{_libexecdir}/*.h
rm $RPM_BUILD_ROOT%{_libexecdir}/*.mk

# core.img - bootable image generated by grub-mkimage(1) via grub-install(1)
touch $RPM_BUILD_ROOT%{_libexecdir}/core.img
touch $RPM_BUILD_ROOT%{_libexecdir}/device.map

%clean
rm -rf $RPM_BUILD_ROOT

%post -p %{_sbindir}/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%postun -p %{_sbindir}/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog NEWS README THANKS TODO
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/grub
%attr(755,root,root) %{_sbindir}/grub-bin2h
%attr(755,root,root) %{_sbindir}/grub-editenv
%attr(755,root,root) %{_sbindir}/grub-fstest
%attr(755,root,root) %{_sbindir}/grub-install
%attr(755,root,root) %{_sbindir}/grub-mkconfig
%attr(755,root,root) %{_sbindir}/grub-mkelfimage
%attr(755,root,root) %{_sbindir}/grub-mkfont
%attr(755,root,root) %{_sbindir}/grub-mkisofs
%attr(755,root,root) %{_sbindir}/grub-mkpasswd-pbkdf2
%attr(755,root,root) %{_sbindir}/grub-mkrelpath
%attr(755,root,root) %{_sbindir}/grub-mkrescue
%attr(755,root,root) %{_sbindir}/grub-reboot
%attr(755,root,root) %{_sbindir}/grub-script-check
%attr(755,root,root) %{_sbindir}/grub-set-default
%attr(755,root,root) %{_sbindir}/update-grub
%ifarch %{ix86} %{x8664}
%attr(755,root,root) %{_sbindir}/grub-mkimage
%{_mandir}/man1/grub-mkimage.1*
%else
%attr(755,root,root) %{_sbindir}/grub-probe
%attr(755,root,root) %{_sbindir}/grub-mkdevicemap
%{_mandir}/man8/grub-probe.8*
%{_mandir}/man8/grub-mkdevicemap.8*
%endif
%{_mandir}/man1/grub-bin2h.1*
%{_mandir}/man1/grub-editenv.1*
%{_mandir}/man1/grub-fstest.1*
%{_mandir}/man1/grub-mkelfimage.1*
%{_mandir}/man1/grub-mkfont.1*
%{_mandir}/man1/grub-mkisofs.1*
%{_mandir}/man1/grub-mkpasswd-pbkdf2.1*
%{_mandir}/man1/grub-mkrelpath.1*
%{_mandir}/man1/grub-mkrescue.1*
%{_mandir}/man1/grub-script-check.1*
%{_mandir}/man8/grub-install.8*
%{_mandir}/man8/grub-mkconfig.8*
%{_mandir}/man8/grub-reboot.8*
%{_mandir}/man8/grub-set-default.8*
%{_mandir}/man8/update-grub.8*
%if %{with grubemu}
%attr(755,root,root) %{_sbindir}/grub-emu
%{_mandir}/man8/grub-emu.8*
%endif
/lib/grub-mkconfig_lib

%dir %{_libexecdir}
%config(noreplace) %verify(not md5 mtime size) %{_libexecdir}/grub.cfg
%{_libexecdir}/*.lst
%{_libexecdir}/*.mod
%if %{with efiemu}
%ifarch %{x8664}
%{_libexecdir}/efiemu*.o
%endif
%endif
%{_libexecdir}/kernel.img
%ifarch %{ix86} %{x8664} sparc sparc64
%{_libexecdir}/boot.img
%{_libexecdir}/cdboot.img
%{_libexecdir}/diskboot.img
%{_libexecdir}/lnxboot.img
%{_libexecdir}/pxeboot.img
%endif

# generated by grub at runtime
%ghost %{_libexecdir}/device.map
%ghost %{_libexecdir}/core.img

%dir /lib/grub.d
%doc /lib/grub.d/README
%attr(755,root,root) /lib/grub.d/00_header
%attr(755,root,root) /lib/grub.d/10_linux
%attr(755,root,root) /lib/grub.d/30_os-prober
%attr(755,root,root) /lib/grub.d/40_custom

%dir %attr(750,root,root) %{_sysconfdir}/grub.d
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/grub.d/custom.cfg

%ifarch %{ix86} %{x8664}
%attr(755,root,root) %{_sbindir}/grub-mkdevicemap
%attr(755,root,root) %{_sbindir}/grub-probe
%attr(755,root,root) %{_sbindir}/grub-setup
%{_mandir}/man8/grub-mkdevicemap.8*
%{_mandir}/man8/grub-probe.8*
%{_mandir}/man8/grub-setup.8*
%endif

%{_infodir}/grub*.info*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: grub2.spec,v $
Revision 1.83  2010/07/19 22:48:32  glen
- disable grubemu bcond, add notes what to do to fix it

Revision 1.82  2010/07/19 19:24:04  glen
- ac-ppc fixes

Revision 1.81  2010/07/19 09:24:38  glen
- "fix" efiemu on ac-amd64

Revision 1.80  2010/07/19 08:52:53  glen
- builds with am 1:1.11.1-1, fails with 1.10-1, so bump BR

Revision 1.79  2010/07/16 17:49:13  glen
- package new files
- make build for ac

Revision 1.78  2010/05/21 21:38:17  shadzik
- include grub-mkrelpath
- rel 0.2 - update-grub fails

Revision 1.77  2010/05/21 21:14:02  shadzik
- up to 1.98
- rel 0.1 - grub-emu doesn't exist?

Revision 1.76  2010/03/16 16:25:01  uzsolt
- hu
- todo about subpackages

Revision 1.75  2010/03/10 16:28:56  glen
- display diagnostic messages to stdout instead of stderr, so one can make
  silent grub mkconfig run >/dev/null, but still see error messages
- rel 2

Revision 1.74  2010/01/24 21:25:38  adamg
- updated to 1.97.2 (license fixes)

Revision 1.73  2010/01/15 20:27:26  sparky
- don't use %{!?without_...} - it's a double negation !

Revision 1.72  2010/01/12 10:56:33  glen
- move probe scripts to /lib/grub.d, /etc/grub.d now contains true configs; rel 7

Revision 1.71  2009/12/13 18:18:08  glen
- release 6

Revision 1.70  2009/12/13 10:09:29  sls
- BR: help2man

Revision 1.69  2009/11/17 23:07:13  adamg
- cosmetics

Revision 1.68  2009/11/17 17:44:32  glen
- ac deps; rel 5

Revision 1.67  2009/11/17 17:37:13  glen
- efiemu32.o/efiemu64.o on x86_64 only

Revision 1.66  2009/11/17 17:32:23  glen
- th-builders don't have %{_infodir}/dir installed

Revision 1.65  2009/11/17 15:22:45  glen
- BR: texinfo for info docs building

Revision 1.64  2009/11/17 15:06:30  glen
- lvm modename rewrite as in geninitrd; rel 4

Revision 1.63  2009/11/17 14:57:27  glen
- do not overwrite grub.d/40_custom on upgrade

Revision 1.62  2009/11/17 14:06:23  glen
- update desc from homepage; rel 3

Revision 1.61  2009/11/17 13:31:38  glen
- package core.img and device.map ghosts

Revision 1.60  2009/11/17 11:12:15  glen
- restore grub-install.in.patch from grub-legacy

Revision 1.59  2009/11/17 10:48:42  glen
- no shell scripts to /boot partition

Revision 1.58  2009/11/12 09:48:56  glen
- ehm, grub.cfg is not a dir

Revision 1.57  2009/11/12 09:48:33  glen
- macros cleanup

Revision 1.56  2009/11/12 07:55:45  glen
- add grub-garbage.patch from fedora

Revision 1.55  2009/11/11 16:55:54  glen
- add sysconfig/grub

Revision 1.54  2009/11/11 16:25:56  glen
- add upgrade-grub from debian

Revision 1.53  2009/11/11 15:38:16  glen
- find pld initrd images with grub-install; rel 2

Revision 1.52  2009/11/11 14:55:57  glen
- check-files shutup, no extra /bin/sh dep

Revision 1.51  2009/11/10 07:39:20  arekm
- up to 1.97.1

Revision 1.50  2009/10/28 08:50:49  adamg
- updated to 1.97

Revision 1.49  2009/09/23 17:47:55  arekm
- up to 20090923; package info docs

Revision 1.48  2009/09/05 10:21:24  arekm
- up to 20090905

Revision 1.47  2009/07/10 11:29:11  arekm
- ppc fixes

Revision 1.46  2009/07/10 11:14:06  arekm
- up to 20090710; should fix ppc build

Revision 1.45  2009/07/10 11:01:50  arekm
- add example grub.cfg

Revision 1.44  2009/07/10 10:12:47  arekm
- fix file dups

Revision 1.43  2009/03/28 22:03:36  arekm
- up to svn version; use standard /boot/grub place (it's supposed to replace
  grub.spec package); include man pages; drop obsolete todo

Revision 1.42  2009/01/31 12:02:58  patrys
- properly detect initrd images

Revision 1.41  2009/01/02 11:51:10  wiget
- semicolon added in grub-1.96/normal/parser.y:58 (grub2-parser.patch)
- added bcond_without grubemu (build grub-emu binary)
- more files included in package
- adapterized
  Based on patch by Daniel Dawid Majewski (Message-ID: <49455C60.8000000@o2.pl>)

Revision 1.40  2008/02/04 19:37:45  arekm
- 1.96

Revision 1.39  2007/06/08 10:49:02  arekm
- BR: gcc-multilib

Revision 1.38  2007/02/14 21:42:50  qboosh
- resolved conflict

Revision 1.37  2007/02/13 07:16:47  glen
- tabs in preamble

Revision 1.36  2007/02/12 00:48:54  baggins
- converted to UTF-8

Revision 1.35  2006/12/05 18:54:29  glen
- it uses -m32 when compiling

Revision 1.34  2006/12/05 18:52:01  glen
- 755 for binaries

Revision 1.33  2006/12/05 18:23:27  glen
- builds for me too when switching to gawk

Revision 1.32  2006/12/05 17:41:41  darekr
- BR: bison

Revision 1.31  2006/12/05 17:37:07  arekm
- builds now

Revision 1.30  2006/12/05 16:53:04  glen
- 1.95, stalls on mawk ...

Revision 1.29  2006/04/24 08:48:01  adamg
- %files fix

Revision 1.28  2006/03/16 20:21:11  sparky
- mode /boot/grub -> /boot/grub2 changes
- version is 1.93

Revision 1.27  2006/03/16 20:06:24  sparky
- up to 20060314, builds on ppc

Revision 1.26  2006/01/16 19:38:53  sparky
- package grub-instal on ppc, build on it

Revision 1.25  2006/01/16 19:33:09  sparky
- updated to latest snapshot (20060103), builds on ix86

Revision 1.24  2005/10/28 20:40:13  sparky
- fixed sparc64 makefile, i see no way to make sparc64 (or other) crosscompilation :/

Revision 1.23  2005/10/28 18:46:49  sparky
- BUILD_CC -> CC, redefining only neaded on x8664
- -Incurses on CFLAGS is not neaded anymore
- TODO: crosscompiling sparc -> sparc64 ? 64 bit ncurses may be neaded

Revision 1.22  2005/10/28 17:56:35  sparky
- mv /sbin/grub{,2}-install, conflicts with grub legacy

Revision 1.21  2005/10/28 17:30:49  sparky
- BR: automake
- unpackaged files

Revision 1.20  2005/10/26 08:07:02  sparky
- new snap (not tested) just to point there is (will be) new arch: sparc64

Revision 1.19  2005/06/30 23:13:09  sparky
- update to yesterday snapshot
- on ppc works a little better but i still can't boot linux

Revision 1.18  2005/05/11 15:27:01  qboosh
- use x8664 macro

Revision 1.17  2005/04/17 15:31:03  paszczus
- updated to 20050517 snap

Revision 1.16  2005/04/01 18:32:24  qboosh
- cleanup

Revision 1.15  2005/04/01 11:42:26  glen
- typo ;)

Revision 1.14  2005/04/01 11:04:02  sparky
- fixer few hardcoded paths

Revision 1.13  2005/04/01 10:45:25  sparky
- full static linking support

Revision 1.12  2005/03/31 22:48:55  sparky
- like this works better, but grub-emu not linked statically

Revision 1.11  2005/03/31 22:34:30  averne
- support for static linking
- NFY KJM

Revision 1.10  2005/03/31 21:13:06  paszczus
- updated to 20050330 snap

Revision 1.9  2005/03/31 12:01:21  sparky
- amd64 fixes
- lzo not required on ppc

Revision 1.8  2005/03/27 20:19:48  sparky
- attempt to make it work (in future) on amd64

Revision 1.7  2005/03/27 18:08:41  sparky
- put all executables in /sbin
- explicit files listing
- removed commented lines

Revision 1.6  2005/03/27 15:54:26  sparky
- file placement and %files fixes
- rel 0.1, not 1
- License: GPL v2

Revision 1.5  2005/03/27 14:33:49  sparky
- +arch ppc, builds but...
- TODO changed
- cut or commented unnecesary things
- ver 1.90, as configure.ac says
- cut changelog
- ruby, yuck :(
- still playing with this

Revision 1.4  2005/03/27 09:57:37  paszczus
- URL for grub2

Revision 1.3  2005/03/27 09:44:59  averne
- copy config.sub

Revision 1.2  2005/03/27 09:42:01  paszczus
- added amd64

Revision 1.1  2005/03/27 09:38:15  paszczus
- started DEVEL version of grub2
- this spec is just for test.. if you really want you can fix desc, summary and others...
